#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int a, b, c, d;
  cin >> a >> b >> c >> d;
  auto dist = [&] (int a, int b, int c, int d) {
    return sqrt((a - c) * (a - c) + (b - d) * (b - d));
  };
  int n;
  cin >> n;
  double ans = 1e10;
  while (n --) {
    int x, y, t;
    cin >> x >> y >> t;
    ans = min(ans, dist(a,b,x,y)+dist(x,y,c,d) + t);
  }
  cout.precision(20);
  cout << ans << endl;
}
