// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXC = 1000, MAXN = 1000, MAXT = 1000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	int xs = inf.readInt(-MAXC, MAXC, "x_s");
	inf.readSpace();
	int ys = inf.readInt(-MAXC, MAXC, "y_s");
	inf.readSpace();
	int xt = inf.readInt(-MAXC, MAXC, "x_t");
	inf.readSpace();
	int yt = inf.readInt(-MAXC, MAXC, "y_t");
	inf.readEoln();

	if (validator.group() == "1") {
		ensuref(ys == 0 && yt == 0, "all y coordinates should be equal to 0 in group #1");
	}

	int n = inf.readInt(1, MAXN, "n");
	inf.readEoln();

	if (validator.group() == "2") {
		ensuref(n == 1, "n should be equal to 1 in group #2");
	}

	for (int i = 0; i < n; ++i) {
		int x = inf.readInt(-MAXC, MAXC, "x");
		inf.readSpace();
		int y = inf.readInt(-MAXC, MAXC, "y");
		inf.readSpace();
		int t = inf.readInt(1, MAXT, "t");
		inf.readEoln();

		if (validator.group() == "1") {
			ensuref(y == 0, "all y coordinates should be equal to 0 in group #1");
		}
	}

	inf.readEof();

	return 0;
}